%define _requires_exceptions perl(this)

%define name	MySQL50
%define version	5.0.2
%define release	0.3mdk

%define major	15
%define libname	%mklibname mysql %{major}

%define muser	mysql
%define var	/var

Summary:	MySQL: a very fast and reliable SQL database engine
Name: 		%{name}
Version:	%{version}
Release:	%{release}
Group:		Databases
License:	GPL
Source0:	mysql-%{version}-alpha.tar.gz
Source1:	mysql-%{version}-alpha.tar.gz.asc
Patch0:		mysql-4.1.3-init.diff.bz2
Patch1:		mysql-5.0.1-alpha-fix_install_scripts.diff.bz2
Patch2:		mysql-4.1.3-lib64.diff.bz2
Patch3:		mysql-4.0.17-no_logger.patch.bz2
Patch4:		mysql-5.0.1-alpha-major.diff.bz2
Patch5:		mysql-5.0.1-alpha-manual_split.diff.bz2
Patch6:		mysql-errno.patch.bz2
URL:		http://www.mysql.com
Prereq:		rpm-helper
PreReq:		MySQL50-common = %{version}-%{release}
BuildRequires:	autoconf2.5
BuildRequires:	automake1.7
BuildRequires:	bison
BuildRequires:	glibc-static-devel
BuildRequires:	libstdc++-static-devel
BuildRequires:	libtermcap-devel
BuildRequires:	ncurses-devel
BuildRequires:	openssl-static-devel
BuildRequires:	python
BuildRequires:	tetex
BuildRequires:	texinfo
BuildRequires:	zlib-devel
BuildRequires:  readline-devel
BuildConflicts:	libedit-devel
Provides:	MySQL50-server
Conflicts:	MySQL-server
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
The MySQL(TM) software delivers a very fast, multi-threaded, multi-user,
and robust SQL (Structured Query Language) database server. MySQL Server
is intended for mission-critical, heavy-load production systems as well
as for embedding into mass-deployed software. MySQL is a trademark of
MySQL AB.

The MySQL software has Dual Licensing, which means you can use the MySQL
software free of charge under the GNU General Public License
(http://www.gnu.org/licenses/). You can also purchase commercial MySQL
licenses from MySQL AB if you do not wish to be bound by the terms of
the GPL. See the chapter "Licensing and Support" in the manual for
further info.

The MySQL web site (http://www.mysql.com/) provides the latest
news and information about the MySQL software. Also please see the
documentation and the manual for more information.

%package	Max
Summary:	MySQL - server with Berkeley DB and Innodb support
Group:		Databases
PreReq:		rpm-helper
PreReq:		MySQL50-common = %{version}-%{release}
Provides:	MySQL50-server
Conflicts:	MySQL-server

%description	Max 
Optional MySQL server binary that supports features
like transactional tables. You can use it as an alternate
to MySQL basic server.

%package	NDB
Summary:	MySQL - server with Berkeley DB, Innodb and NDB Cluster support
Group:		Databases
PreReq:		rpm-helper
PreReq:		MySQL50-common = %{version}-%{release}
Provides:	MySQL50-server
Conflicts:	MySQL-server

%description	NDB 
Optional MySQL server binary that supports features
like transactional tables. You can use it as an alternate
to MySQL basic server.

Additional features:

* Archive Storage Engine
* NDB Cluster table handler

%package	common
Summary:	MySQL: common files
Group:		Databases
Prereq:		rpm-helper
Requires:	MySQL50-client
#Requires:	perl-Mysql
Conflicts:	MySQL-common

%description	common
Common files for the MySQL(TM) database server.

%package	client
Summary:	MySQL - Client
Group:		Databases
Requires:	%{libname} = %{version}-%{release}
Conflicts:	MySQL-client

%description	client
This package contains the standard MySQL clients.

%package	bench
Summary:	MySQL - Benchmarks and test system
Group:		Databases
Requires:	MySQL50-client = %{version}-%{release}
Requires:	perl
Conflicts:	MySQL-bench

%description	bench
This package contains MySQL benchmark scripts and data.

%package -n	%{libname}
Summary:	MySQL - Shared libraries
Group:		System/Libraries

%description -n	%{libname}
This package contains the shared libraries (*.so*) which certain
languages and applications need to dynamically load and use MySQL.

%package -n	%{libname}-devel
Summary:	MySQL - Development header files and libraries
Group:		Development/Other
Obsoletes:	MySQL50-devel
Provides:	MySQL50-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
#Requires:	MySQL50-common = %{version}-%{release}
#Requires:	MySQL50-client = %{version}-%{release}
#Provides:	libmysql-devel
Conflicts:	MySQL-devel

%description -n	%{libname}-devel
This package contains the development header files and libraries
necessary to develop MySQL client applications.

This package also contains the MySQL server as an embedded library.

The embedded MySQL server library makes it possible to run a
full-featured MySQL server inside the client application.
The main benefits are increased speed and more simple management
for embedded applications.

The API is identical for the embedded MySQL version and the
client/server version.

%prep

%setup -q -n mysql-%{version}-alpha
%patch0 -p0 -b .init
%patch1 -p0 -b .max
%patch2 -p1 -b .lib64
%patch3 -p1 -b .log
%patch4 -p0 -b .major
%patch5 -p0 -b .manual_split
%patch6 -p1 -b .errno_as_defines

# fix a bug somewhere in the make docs logic. this is a rude hack, but it seems to
# make it able to build 4.1.7 on 10.0
mkdir -p Docs/Images
touch Docs/Images/myaccess-odbc.txt Docs/Images/myaccess.txt Docs/Images/myarchitecture.txt \
Docs/Images/mydll-properties.txt Docs/Images/mydsn-example.txt Docs/Images/mydsn-icon.txt \
Docs/Images/mydsn-options.txt Docs/Images/mydsn-setup.txt Docs/Images/mydsn-test-fail.txt \
Docs/Images/mydsn-test-success.txt Docs/Images/mydsn-trace.txt Docs/Images/mydsn.txt \
Docs/Images/myflowchart.txt

%build
# pass correct MYSQLD_DEFAULT_SWITCHES
perl -pi -e "s|MYSQLD_DEFAULT_SWITCHES=\"--skip-locking\"|MYSQLD_DEFAULT_SWITCHES=\"--skip-locking --tmpdir=/tmp\"|g" configure*

# Run aclocal in order to get an updated libtool.m4 in generated
# configure script for "new" architectures (aka. x86_64, mips)
export WANT_AUTOCONF_2_5=1
libtoolize --copy --force; aclocal-1.7; autoconf; automake-1.7

%serverbuild

# (gb) We shall always have the fully versioned binary
# FIXME: Please, please, do tell why you need fully qualified version
GCC_VERSION=`gcc -dumpversion`
export CFLAGS="$CFLAGS"
export CC="gcc-$GCC_VERSION"
export CXX="g++-$GCC_VERSION"


%ifarch alpha
export CXXFLAGS="$CXXFLAGS -fPIC"
%else
export CXXFLAGS="$CXXFLAGS"
%endif

BuildMySQL() {
# The --enable-assembler simply does nothing on systems that does not
# support assembler speedups.

%configure2_5x \
 	    $* \
	    --enable-assembler \
	    --enable-local-infile \
	    --enable-large-files=yes \
	    --enable-largefile=yes \
	    --without-readline \
            --with-mysqld-user=%{muser} \
            --with-unix-socket-path=/var/lib/mysql/mysql.sock \
            --prefix=/ \
	    --with-extra-charsets=complex \
            --exec-prefix=%{_prefix} \
            --libexecdir=%{_sbindir} \
            --sysconfdir=%{_sysconfdir} \
            --datadir=%{_datadir} \
            --localstatedir=%{_localstatedir}/mysql \
            --infodir=%{_infodir} \
            --includedir=%{_includedir} \
            --mandir=%{_mandir} \
            --program-prefix= ;

# benchdir does not fit in above model. Maybe a separate bench distribution
# pass correct MYSQLD_DEFAULT_SWITCHES
%make benchdir_root=%{buildroot}%{_datadir}
}

# build mysqld-max
BuildMySQL "--enable-shared \
		--with-openssl \
		--with-berkeley-db \
		--with-innodb \
		--without-raid \
		--with-embedded-server \
		--with-server-suffix='-Max'"

# Save mysqld-max
mv sql/mysqld sql/mysqld-max
nm --numeric-sort sql/mysqld-max > sql/mysqld-max.sym

# tuck away the embedded enabled static library
cp libmysqld/libmysqld.a _libmysqld.a_

# Save manual to avoid rebuilding
mv Docs/manual.ps Docs/manual.ps.save
make clean
mv Docs/manual.ps.save Docs/manual.ps

automake-1.7

# build mysqld-ndb
BuildMySQL "--enable-shared \
		--with-openssl \
		--with-berkeley-db \
		--with-innodb \
		--without-raid \
		--without-embedded-server \
		--with-example-storage-engine \
		--with-archive-storage-engine \
		--with-ndbcluster \
		--with-ndb-shm \
		--with-ndb-docs \
		--with-server-suffix='-NDB'"

# --with-ndb-sci requires stuff from http://www.dolphinics.no/
# --with-ndb-test won't compile

# Save mysqld-ndb
mv sql/mysqld sql/mysqld-ndb
nm --numeric-sort sql/mysqld-ndb > sql/mysqld-ndb.sym

#now build and save shared libraries

# RPM:s destroys Makefile.in files, so we generate them here
automake-1.7

# build mysqld
BuildMySQL "--enable-shared \
		--enable-thread-safe-client \
		--with-openssl \
		--without-berkeley-db \
		--with-innodb \
		--without-raid \
		--without-embedded-server \
		--without-vio"

nm --numeric-sort sql/mysqld > sql/mysqld.sym


cat > README.MDK << EOF
MySQL server is present under 3 flavours, MySQL, MySQL-Max and MySQL-NDB
They cannot be installed side by side.

MySQL rpm is compiled with the following option :
--enable-assembler
--enable-thread-safe-client
--with-openssl
--without-berkeley-db
--with-innodb
--without-embedded-server
--without-vio

MySQL-Max rpm is compiled with :
--enable-assembler
--with-openssl
--with-berkeley-db
--with-innodb
--with-embedded-server

MySQL-NDB rpm is compiled with :
--enable-assembler
--with-openssl
--with-berkeley-db
--with-innodb
--without-embedded-server
--with-example-storage-engine
--with-archive-storage-engine
--with-ndbcluster
--with-ndb-shm
--with-ndb-docs

See the spec files on http://cvs.mandrakesoft.com/SPECS/MySQL50/ for 
more details.
EOF

%install 
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_sysconfdir}/logrotate.d
install -d %{buildroot}%{_initrddir}
install -d %{buildroot}%{_localstatedir}/mysql/mysql
install -d %{buildroot}%{_datadir}/sql-bench
install -d %{buildroot}%{_datadir}/mysql-test
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_datadir}
install -d %{buildroot}%{_mandir}
install -d %{buildroot}%{_includedir}
install -d %{buildroot}%{_infodir}
install -d %{buildroot}%{_docdir}/%{name}-%{version}
install -d %{buildroot}%{_docdir}/%{name}-%{version}/chapter
install -d %{buildroot}%{_libdir}

make install DESTDIR=%{buildroot} benchdir_root=%{_datadir}

# install saved mysqld-max
install -m755 sql/mysqld-max %{buildroot}%{_sbindir}/mysqld-max
install -m644 _libmysqld.a_ %{buildroot}%{_libdir}/mysql/libmysqld.a
install -m755 sql/mysqld-ndb %{buildroot}%{_sbindir}/mysqld-ndb

# install symbol files ( for stack trace resolution)
install -m644 sql/mysqld-max.sym %{buildroot}%{_libdir}/mysql/mysqld-max.sym
install -m644 sql/mysqld.sym %{buildroot}%{_libdir}/mysql/mysqld.sym
install -m644 sql/mysqld-ndb.sym %{buildroot}%{_libdir}/mysql/mysqld-ndb.sym

install -m644 support-files/mysql-log-rotate %{buildroot}%{_sysconfdir}/logrotate.d/mysql

perl -pi -e 's/# chkconfig: 2345 90 90/# chkconfig: 2345 90 10/' support-files/mysql.server
install -m755 support-files/mysql.server %{buildroot}%{_initrddir}/mysql

install -m755 support-files/mysql.server %{buildroot}%{_initrddir}/mysql-max
perl -pi -e 's/status mysqld/status mysqld-max/g;s,(/var/lock/subsys/mysql),$1-max,' %{buildroot}%{_initrddir}/mysql-max

install -m755 support-files/mysql.server %{buildroot}%{_initrddir}/mysql-ndb
perl -pi -e 's/status mysqld/status mysqld-ndb/g;s,(/var/lock/subsys/mysql),$1-ndb,' %{buildroot}%{_initrddir}/mysql-ndb

# Install docs
install -m644 Docs/mysql.info %{buildroot}%{_infodir}/mysql.info

# Fix libraries
mv %{buildroot}%{_libdir}/mysql/libmysqlclient.* %{buildroot}%{_libdir}/
mv %{buildroot}%{_libdir}/mysql/libmysqlclient_r.* %{buildroot}%{_libdir}/
perl -pi -e "s|%{_libdir}/mysql|%{_libdir}|" %{buildroot}%{_libdir}/libmysqlclient.la %{buildroot}%{_libdir}/libmysqlclient_r.la

pushd %{buildroot}%{_bindir}
    ln -sf mysqlcheck mysqlrepair
    ln -sf mysqlcheck mysqlanalyze
    ln -sf mysqlcheck mysqloptimize
popd

mysql_datadir=%{buildroot}%{_localstatedir}/mysql
# Create data directory if needed
if test ! -d $mysql_datadir;		then mkdir -p $mysql_datadir; fi
if test ! -d $mysql_datadir/mysql;	then mkdir $mysql_datadir/mysql; fi
if test ! -d $mysql_datadir/test;	then mkdir $mysql_datadir/test; fi
chmod -R og-rw $mysql_datadir/mysql

# house cleaning
rm -f %{buildroot}%{_datadir}/info/dir
rm -f %{buildroot}%{_bindir}/make_win_src_distribution
rm -f %{buildroot}%{_bindir}/make_win_binary_distribution
rm -f %{buildroot}%{_datadir}/mysql/*.spec
rm -f %{buildroot}%{_datadir}/mysql/postinstall
rm -f %{buildroot}%{_datadir}/mysql/preinstall
rm -f %{buildroot}%{_datadir}/mysql/mysql-log-rotate
rm -f %{buildroot}%{_datadir}/mysql/mysql.server

%find_lang mysql

cat >> mysql.lang << EOF 
%lang(cz) %{_datadir}/mysql/czech
%lang(da) %{_datadir}/mysql/danish
%lang(nl) %{_datadir}/mysql/dutch
%lang(et) %{_datadir}/mysql/estonian
%lang(fr) %{_datadir}/mysql/french
%lang(de) %{_datadir}/mysql/german
%lang(el) %{_datadir}/mysql/greek
%lang(hu) %{_datadir}/mysql/hungarian
%lang(it) %{_datadir}/mysql/italian
%lang(jp) %{_datadir}/mysql/japanese
%lang(ko) %{_datadir}/mysql/korean
%lang(no) %{_datadir}/mysql/norwegian
%lang(no_ny) %{_datadir}/mysql/norwegian-ny
%lang(pl) %{_datadir}/mysql/polish
%lang(pt) %{_datadir}/mysql/portuguese
%lang(ro) %{_datadir}/mysql/romanian
%lang(ru) %{_datadir}/mysql/russian
%lang(sl) %{_datadir}/mysql/slovak
%lang(es) %{_datadir}/mysql/spanish
%lang(sv) %{_datadir}/mysql/swedish
%lang(uk) %{_datadir}/mysql/ukrainian
%lang(sr) %{_datadir}/mysql/serbian
EOF

# this one doesn't belong here...
mv %{buildroot}%{_bindir}/client_test %{buildroot}%{_datadir}/mysql-test/

%pre common
%_pre_useradd %{muser} %{_localstatedir}/mysql /bin/bash

%post common
%_install_info mysql.info

%post
# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R %{muser}:%{muser} %{_localstatedir}/mysql

# Initiate databases
mysql_install_db --rpm --user=%{muser}

# Change permissions again to fix any new files.
chown -R %{muser}:%{muser} %{_localstatedir}/mysql

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw %{_localstatedir}/mysql

%_post_service mysql

# Allow mysqld_safe to start mysqld and print a message before we exit
sleep 2

# try to fix privileges table, use a no password user table for that
fix_privileges() 
{
    datadir=`my_print_defaults mysqld | grep '^--datadir=' | cut -d= -f2`
    if [ -z $datadir ]; then
        datadir=%{_localstatedir}/mysql/
    fi
    cd $datadir/mysql
    pid_file=$datadir/mysql.pid
    if %{_bindir}/mysqld_safe --skip-grant-tables --skip-networking --pid-file=$pid_file --tmpdir=/tmp &> /dev/null & then  
        pid=$!
        i=1
        while [ $i -lt 10 -a ! -f $pid_file ]; do 
            i=$(($i+1))
            sleep 1
        done
        if [ -f $datadir/mysql.pid ]; then
            %{_bindir}/mysql_fix_privilege_tables &> /dev/null 
            kill `cat $pid_file` &> /dev/null
            rm -f $pid_file
        else 
            # just in case
            kill $pid &> /dev/null
        fi
        sleep 2
    fi
}

if [ -f /var/lock/subsys/mysql ]; then
    /sbin/service mysql stop &> /dev/null
    fix_privileges
    /sbin/service mysql start &> /dev/null 
else
    fix_privileges
fi

%post Max
# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R %{muser}:%{muser} %{_localstatedir}/mysql

# Initiate databases
mysql_install_db --rpm --user=%{muser}

# Change permissions again to fix any new files.
chown -R %{muser}:%{muser} %{_localstatedir}/mysql

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw %{_localstatedir}/mysql

%_post_service mysql-max
# Allow mysqld_safe to start mysqld and print a message before we exit
sleep 2

# try to fix privileges table, use a no password user table for that
fix_privileges() 
{
    datadir=`my_print_defaults mysqld | grep '^--datadir=' | cut -d= -f2`
    if [ -z $datadir ]; then
        datadir=%{_localstatedir}/mysql/
    fi
    cd $datadir/mysql
    pid_file=$datadir/mysql.pid
    if %{_bindir}/mysqld_safe --skip-grant-tables --skip-networking --pid-file=$pid_file --tmpdir=/tmp &> /dev/null & then  
        pid=$!
        i=1
        while [ $i -lt 10 -a ! -f $pid_file ]; do 
            i=$(($i+1))
            sleep 1
        done
        if [ -f $datadir/mysql.pid ]; then
            %{_bindir}/mysql_fix_privilege_tables &> /dev/null 
            kill `cat $pid_file` &> /dev/null
            rm -f $pid_file
        else 
            # just in case
            kill $pid &> /dev/null
        fi
        sleep 2
    fi
}

if [ -f /var/lock/subsys/mysql ]; then
    /sbin/service mysql-max stop &> /dev/null
    fix_privileges
    /sbin/service mysql-max start &> /dev/null 
else
    fix_privileges
fi



%post NDB
# Change permissions so that the user that will run the MySQL daemon
# owns all database files.
chown -R %{muser}:%{muser} %{_localstatedir}/mysql

# Initiate databases
mysql_install_db --rpm --user=%{muser}

# Change permissions again to fix any new files.
chown -R %{muser}:%{muser} %{_localstatedir}/mysql

# Fix permissions for the permission database so that only the user
# can read them.
chmod -R og-rw %{_localstatedir}/mysql

%_post_service mysql-ndb
# Allow mysqld_safe to start mysqld and print a message before we exit
sleep 2

# try to fix privileges table, use a no password user table for that
fix_privileges() 
{
    datadir=`my_print_defaults mysqld | grep '^--datadir=' | cut -d= -f2`
    if [ -z $datadir ]; then
        datadir=%{_localstatedir}/mysql/
    fi
    cd $datadir/mysql
    pid_file=$datadir/mysql.pid
    if %{_bindir}/mysqld_safe --skip-grant-tables --skip-networking --pid-file=$pid_file --tmpdir=/tmp &> /dev/null & then  
        pid=$!
        i=1
        while [ $i -lt 10 -a ! -f $pid_file ]; do 
            i=$(($i+1))
            sleep 1
        done
        if [ -f $datadir/mysql.pid ]; then
            %{_bindir}/mysql_fix_privilege_tables &> /dev/null 
            kill `cat $pid_file` &> /dev/null
            rm -f $pid_file
        else 
            # just in case
            kill $pid &> /dev/null
        fi
        sleep 2
    fi
}

if [ -f /var/lock/subsys/mysql ]; then
    /sbin/service mysql-max stop &> /dev/null
    fix_privileges
    /sbin/service mysql-max start &> /dev/null 
else
    fix_privileges
fi

%preun
%_preun_service mysql
# We do not remove the mysql user since it may still own a lot of
# database files.

%preun common
%_remove_install_info mysql.info

%preun Max
%_preun_service mysql-max

%preun NDB
%_preun_service mysql-ndb

%post -n %{libname} -p /sbin/ldconfig

%postun -n %{libname} -p /sbin/ldconfig

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root) 
%doc README.MDK
%config(noreplace) %{_initrddir}/mysql
%{_sbindir}/mysqld
%{_libdir}/mysql/mysqld.sym
%dir %{_libdir}/mysql

%files Max
%defattr(-,root,root)
%config(noreplace) %{_initrddir}/mysql-max
%{_sbindir}/mysqld-max
%{_libdir}/mysql/mysqld-max.sym
%dir %{_libdir}/mysql

%files NDB
%defattr(-,root,root)
%config(noreplace) %{_initrddir}/mysql-ndb
%{_sbindir}/mysqld-ndb
%{_libdir}/mysql/mysqld-ndb.sym
%dir %{_libdir}/mysql

%files client
%defattr(-,root,root)
%{_bindir}/msql2mysql
%{_bindir}/mysql
%{_bindir}/mysqlaccess
%{_bindir}/mysqladmin
%{_bindir}/mysqlcheck
%{_bindir}/mysqlrepair
%{_bindir}/mysqlanalyze
%{_bindir}/mysqloptimize
%{_bindir}/mysql_find_rows
%{_bindir}/mysqldump
%{_bindir}/mysqldumpslow
%{_bindir}/mysqlimport
%{_bindir}/mysqlshow
%{_bindir}/mysqlbinlog
%{_mandir}/man1/*.1*
      
%files bench
%defattr(-,root,root)
%doc sql-bench/README
%{_datadir}/sql-bench
%{_datadir}/mysql-test

%files common -f mysql.lang
%defattr(-,root,root) 
%doc README COPYING Docs/*.html Docs/*.txt Docs/*.texi Docs/*.ps support-files/*.cnf Docs/manual-split
%config(noreplace) /etc/logrotate.d/mysql
%{_bindir}/isamchk
%{_bindir}/isamlog
%{_bindir}/pack_isam
%{_bindir}/myisamchk
%{_bindir}/myisamlog
%{_bindir}/myisampack
%{_bindir}/mysql_fix_privilege_tables
%{_bindir}/mysql_convert_table_format
%{_bindir}/mysql_install_db
%{_bindir}/mysql_setpermission
%{_bindir}/mysql_explain_log 
%{_bindir}/mysql_fix_extensions 
%{_bindir}/mysql_secure_installation 
%{_bindir}/mysql_tableinfo 
%{_bindir}/mysql_waitpid 
%{_bindir}/mysql_create_system_tables
%{_bindir}/mysql_tzinfo_to_sql
%{_bindir}/mysqlmanager-pwgen 
%{_bindir}/mysqlmanager
%{_bindir}/mysqlmanagerc 
%{_bindir}/mysql_zap
%{_bindir}/mysqlbug
%{_bindir}/mysqltest
%{_bindir}/mysqlhotcopy
%{_bindir}/perror
%{_bindir}/replace
%{_bindir}/resolveip
%{_bindir}/resolve_stack_dump
%{_bindir}/mysqld_safe
%{_bindir}/mysqld_multi
%{_bindir}/my_print_defaults
%{_bindir}/myisam_ftdump
%{_infodir}/mysql.info*
%dir %attr(-,%{muser},%{muser}) %{_localstatedir}/mysql
%dir %attr(-,%{muser},%{muser}) %{_localstatedir}/mysql/mysql
%dir %attr(-,%{muser},%{muser}) %{_localstatedir}/mysql/test
%dir %{_datadir}/mysql
%{_datadir}/mysql/mi_test_all
%{_datadir}/mysql/mi_test_all.res
%{_datadir}/mysql/*.cnf
%{_datadir}/mysql/charsets
%{_datadir}/mysql/english
%{_datadir}/mysql/Description.plist
%{_datadir}/mysql/Info.plist
%{_datadir}/mysql/StartupParameters.plist
%{_datadir}/mysql/fill_help_tables.sql
%{_datadir}/mysql/mysql_fix_privilege_tables.sql

%files -n %{libname}
%defattr(-,root,root)
%doc ChangeLog
# Shared olibraries (omit for architectures that don't support them)
%{_libdir}/*.so.*

%files -n %{libname}-devel
%defattr(-,root,root)
%doc INSTALL-SOURCE
%{_bindir}/comp_err
%{_bindir}/mysql_config
%dir %{_libdir}/mysql
%{_libdir}/mysql/libdbug.a
%{_libdir}/mysql/libheap.a
%{_libdir}/mysql/libmerge.a
%{_libdir}/mysql/libmyisam.a
%{_libdir}/mysql/libmyisammrg.a
%{_libdir}/mysql/libmysqld.a
%{_libdir}/mysql/libmystrings.a
%{_libdir}/mysql/libmysys.a
%{_libdir}/mysql/libnisam.a
%{_libdir}/mysql/libvio.a
%{_libdir}/*.la
%{_libdir}/*.so
%{_libdir}/*.a
%{_includedir}/mysql

%changelog
* Fri Jan 21 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 5.0.2-0.3mdk
- added some conflicts
- added P6 (fedora)
- added --enable-large-files=yes --enable-largefile=yes
- link against system readline

* Tue Dec 14 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 5.0.2-0.2mdk
- fix bugs in the init script
- fix deps

* Thu Dec 02 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 5.0.2-0.1mdk
- 5.0.2-alpha

* Sun Oct 31 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 5.0.1-0.3mdk
- new P1
- make it build on 10.0 too
- allways use a TMPDIR we can access
- provide a by chapter split manual (P5)

* Mon Sep 20 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 5.0.1-0.2mdk
- added P4 so the shared libs won't clash with previous versions

* Sat Aug 14 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 5.0.1-0.1mdk
- 5.0.1-alpha
- made the ndb sub package

* Sat Jul 31 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.1.3-0.1mdk
- 4.1.3-beta
- rediffed some patches
- major spec file cleanups

* Thu Jun  3 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.20-3mdk
- rebuilt against gcc3.4
- fix buildrequires: libstdc++-static-devel

* Sat May 29 2004 Michael Scherer <misc@mandrake.org> 4.0.20-2mdk 
- [DIRM]
- fix rebuild
- added README.MDK

* Tue May 18 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.0.20-1mdk
- oops! 4.0.19 was broken (but works for me), pointed out by 
  Benjamin Pflugmann, thanks man!

* Mon May 17 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.0.19-1mdk
- 4.0.19
- fix for CAN-2004-0381, CAN-2004-0388 is included

* Mon May 17 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 4.0.18-2mdk
- security fix for CAN-2004-0381, CAN-2004-0388 (vdanen)
- misc spec file fixes
- remove unused patches (P1, P2, P3, P4, P9, P10)

* Sun Feb 22 2004 Warly <warly@mandrakesoft.com> 4.0.18-1mdk
- new version (bugfixes)
- add innodb support in default MySQL
- do not call logger in initscripts any more to close all local IO references

* Tue Jan 20 2004 Frederic Lepied <flepied@mandrakesoft.com> 4.0.17-2mdk
- fixed strings in init scripts
- add require perl-Mysql in MySQL-common

* Sun Dec 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 4.0.17-1mdk
- 4.0.17
- rediffed P0 and P8
- drop unused P7

* Thu Oct 23 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 4.0.16-1mdk
- 4.0.16
- rediffed P0 and P5
- make it start after network and before any other requiring it (P0)

* Sun Sep 14 2003 Warly <warly@mandrakesoft.com> 4.0.15-1mdk
- Security update

* Fri Aug  8 2003 Warly <warly@mandrakesoft.com> 4.0.14-1mdk
- new version (main changes):
   * Enabled `INSERT' from `SELECT' when the table into which the records are inserted is also a table listed in the `SELECT'.
   * Added `--nice' option to `mysqld_safe' to allow setting the  niceness of the `mysqld' process.
   * `RESET SLAVE' now clears the `Last_errno' and `Last_error' fields in the output of `SHOW SLAVE STATUS'.
   * Added `max_relay_log_size' variable; the relay log will be rotated
     automatically when its size exceeds `max_relay_log_size'. But if
     `max_relay_log_size' is 0 (the default), `max_binlog_size' will be
     used (as in older versions). `max_binlog_size' still applies to
     binary logs in any case.

* Fri Aug  1 2003 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.0.13-4mdk
- lib64 fixes, quotes test fixes
- BuildRequires: termcap-devel for MDK 9.2

* Thu Jul 10 2003 Laurent MONTEL <lmontel@mandrakesoft.com> 4.0.13-3mdk
- Rebuild

* Wed Jun 04 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 4.0.13-2mdk
- brute fix the offending "perl(the)" stuff, remove this when perl.req is fixed.
- fix "no-prereq-on rpm-helper" for MySQL-common
- fix "no-provides libmysql-devel" for libmysql12-devel
- activated %%clean

* Fri May 30 2003 Warly <warly@mandrakesoft.com> 4.0.13-1mdk
- new version (main changes):
Functionality added or changed:
 - `PRIMARY KEY' now implies `NOT NULL'.
 - `SHOW MASTER STATUS' and `SHOW SLAVE STATUS' required the `SUPER'  privilege; now they accept `REPLICATION CLIENT' as well.
 - MySQL now issues a warning when it opens a table that was created with MySQL 4.1.
 - Option `--new' now changes binary items (`0xFFDF') to be treated
   as binary strings instead of numbers by default. This fixes some
   problems with character sets where it's convenient to input the
   string as a binary item.  After this change you have to convert
   the binary string to `INTEGER' with a `CAST' if you want to
   compare two binary items with each other and know which one is
   bigger than the other.  `SELECT CAST(0xfeff AS UNSIGNED) <
   CAST(0xff AS UNSIGNED)'.  This will be the default behaviour in
   MySQL 4.1. (Bug #152)
 - Fixed bug with `NATURAL LEFT JOIN', `NATURAL RIGHT JOIN' and
   `RIGHT JOIN' when using many joined tables.  The problem was that
   the `JOIN' method was not always associated with the tables
   surrounding the `JOIN' method.  If you have a query that uses many
   `RIGHT JOIN' or `NATURAL ... JOINS' you should check that they
   work as you expected after upgrading MySQL to this version.
 - Tuned optimizer to favour clustered index over table scan.
 - `BIT_AND()' and `BIT_OR()' now return an unsigned 64 bit value.
Bugs fixed:
 - Fixed `Unknown error' when using `UPDATE ... LIMIT'.
 - Fixed problem with ansi mode and `GROUP BY' with constants.
 - Fixed bug if one used a multi-table `UPDATE' and the query required a temporary table bigger than `tmp_table_size'.
 - `LOAD DATA INFILE' will now read `000000' as a zero date instead as `"2000-00-00"'.
 - Fixed bug that caused `DELETE FROM table WHERE const_expression' always to delete the whole table.
 - Fixed core dump bug when using `FORMAT('nan',#)'.
 - Fixed wrong result from truncation operator (`*') in `MATCH ... AGAINST()' in some complex joins.
 - Fixed a crash in `REPAIR ... USE_FRM' command, when used on read-only, nonexisting table or a table with a crashed index file.
 - Fixed bug in `LEFT', `RIGHT' and `MID' when used with multi-byte character sets and some `GROUP BY' queries.
 - Fix problem with `ORDER BY' being discarded for some `DISTINCT' queries.
 - Fixed that `SET SQL_BIG_SELECTS=1' works as documented (New bug in 4.0)
 - Fixed some serious bugs in `UPDATE ... ORDER BY'.
 - Fixed that `SET SQL_BIG_SELECTS=1' works again.
 - `FULLTEXT' index stopped working after `ALTER TABLE' that converts `TEXT' field to `CHAR'. 
 - Fixed a security problem with `SELECT' and wildcarded select list, when user only had partial column `SELECT' privileges on the table.
 - Only ignore world-writeable `my.cnf' files that are regular files (and not e.g. named pipes or character devices).
 - `SUM()' didn't return `NULL' when there was no rows in result or  when all values was `NULL'.
 - On Unix symbolic links handling was not enabled by default and there was no way to turn this on.
 - Fixed a bug with `NAN' in `FORMAT(...)' function ...
 - Fixed a bug with improperly cached database privileges.
 - Fixed a bug in `ALTER TABLE ENABLE / DISABLE KEYS' which failed to force a refresh of table data in the cache.
 - Fixed bugs in replication of `LOAD DATA INFILE' for custom parameters (`ENCLOSED',  `TERMINATED' and so on) and temporary tables.
 - Fixed a replication bug when the master is 3.23 and the slave 4.0:  the slave lost the replicated temporary tables if `FLUSH LOGS' was issued on the master.

* Sun May 11 2003 Stefan van der Eijk <stefan@eijk.nu> 4.0.12-3mdk
- BuildRequires openssl-static-devel
- removed redeundant BuildRequires
- fix build on alpha: add -fPIC to CXXFLAGS (thanks glee)

* Fri May  2 2003 Warly <warly@mandrakesoft.com> 4.0.12-2mdk
- buildrequires openssl-devel
- add splitted manual in 'chapter' subdir in doc dir (Steve White)

* Wed Apr  9 2003 Warly <warly@mandrakesoft.com> 4.0.12-1mdk
- new version (main changes):
 * `mysqld' no longer reads options from world-writeable config files.
 * Fixed `mysqld' crash on extremely small values of `sort_buffer' variable.
 * Fixed checking of random part of `WHERE' clause.
 * Don't allow `BACKUP TABLE' to overwrite existing files.
 * Fixed a bug with multi-table `UPDATE's when user had all privileges
   on the database where tables are located and there were any
   entries in `tables_priv' table, i.e. `grant_option' was true.
 * Fixed a bug that allowed a user with table or column grants on
   some table, `TRUNCATE' any table in the same database.
 * Fixed deadlock when doing `LOCK TABLE' followed by `DROP TABLE' in
   the same thread.  In this case one could still kill the thread
   with `KILL'.
 * Fixed query cache invalidation on `LOAD DATA'.
 * Fixed memory leak on `ANALYZE' procedure with error.
 * Fixed a bug in handling `CHAR(0)' columns that could cause wrong results from the query.
 * Fixed a crash when no database was selected and `LOAD DATA' command
   was issued with full table name specified, including database
   prefix.
- add Zdenek Mazanec patch for charset conversion fix

* Wed Mar 12 2003 Warly <warly@mandrakesoft.com> 4.0.11a-5mdk
- Apply Benjamin Pflugmann patch to mysql_install_db

* Sun Mar  9 2003 Warly <warly@mandrakesoft.com> - 4.0.11a-4mdk
- Correct post install scripts and requires

* Thu Mar  6 2003 Warly <warly@mandrakesoft.com> 4.0.11a-3mdk
- MySQL and MySQL-Max conflicts between each others
- include a separate service for mysql and mysql-max in respective server to have clean uninstall
- fix requires in MySQL MySQL-common and MySQL-max
- Try to correct post install script to fix privileges.
- fix initscripts problem with chkconfig --add

* Mon Mar  3 2003 Warly <warly@mandrakesoft.com> 4.0.11a-2mdk
- use --skip-grant-tables --skip-networking for the update process (Benjamin Pflugmann)

* Sat Mar  1 2003  <warly@ke.mandrakesoft.com> 4.0.11a-1mdk
- new version
- new MySQL-common package
- call mysql_fix_privilege_tables in post (but this will fail if
root access need a password)
- add openssl support in MySQL-Max

* Fri Feb  7 2003 Warly <warly@mandrakesoft.com> 4.0.10-1mdk
- new version
- fix initscript

* Thu Feb  6 2003 Warly <warly@mandrakesoft.com> 4.0.9-1mdk
- new version
- do not compile in static anymore
- check mysqld-max on status

* Tue Jan 28 2003 Vincent Danen <vdanen@mandrakesoft.com> 3.23.55-1mdk
- 3.23.55; fixes a double free() in COM_CHANGE_USER
- comment out --with-comment for %%configure as it doesn't seem to like us
  anymore

* Tue Dec 24 2002 Warly <warly@mandrakesoft.com> 3.23.54a-1mdk
- new version

* Wed Nov 20 2002 Warly <warly@mandrakesoft.com> 3.23.53-5mdk
- fix /var/lib/lib/ home dir typo
- remove lang tag to english

* Tue Nov 19 2002 Warly <warly@mandrakesoft.com> 3.23.53-4mdk
- add glibc-static-devel buildrequires

* Tue Nov 19 2002 Warly <warly@mandrakesoft.com> 3.23.53-3mdk
- fix file ownership problems in /var/lib/mysql
- put lang files in %%lang

* Sat Nov  9 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.23.53-2mdk
- Patch3: Fix build on x86-64

* Wed Oct 23 2002 Warly <warly@mandrakesoft.com> 3.23.53-1mdk
- new version
 
* Sun Aug 18 2002 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.52-1mdk
- update from Oden Eriksson <oden.eriksson@kvikkjokk.net>:
	- new stable version

* Sat Aug 10 2002 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.51-4mdk
- fix initscript.

* Wed Jul 17 2002 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 3.23.51-3mdk
- Patch2: Fix --with-other-libc support
- Take care of new CFLAGS from %%serverbuild
- rpmlint fixes: configure-without-libdir-spec, hardcoded-library-path
- Stop hardcoding compiler versions. Why so? and why parts of the
  %%changelog were nuked away??

* Sat Jul  6 2002 Stefan van der Eijk <stefan@eijk.nu> 3.23.51-2mdk
- BuildRequires

* Fri Jun 14 2002 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.51-1mdk
- New version.

* Thu Apr 25 2002 Christian Belisle <cbelisle@mandrakesoft.com> 3.23.50-1mdk
- Synchronize with MySQL official SPEC
- Add InnoDB support
- Build against gcc 3.

* Fri Feb 15 2002 Sasha

- changed build to use --with-other-libc

* Fri Apr 13 2001 Monty

- Added mysqld-max to the distribution

* Tue Jan 2  2001  Monty

- Added mysql-test to the bench package

* Fri Aug 18 2000 Tim Smith <tim@mysql.com>

- Added separate libmysql_r directory; now both a threaded
  and non-threaded library is shipped.

* Wed Sep 28 1999 David Axmark <davida@mysql.com>

- Added the support-files/my-example.cnf to the docs directory.

- Removed devel dependency on base since it is about client
  development.

* Wed Sep 8 1999 David Axmark <davida@mysql.com>

- Cleaned up some for 3.23.

* Thu Jul 1 1999 David Axmark <davida@mysql.com>

- Added support for shared libraries in a separate sub
  package. Original fix by David Fox (dsfox@cogsci.ucsd.edu)

- The --enable-assembler switch is now automatically disables on
  platforms there assembler code is unavailable. This should allow
  building this RPM on non i386 systems.

* Mon Feb 22 1999 David Axmark <david@detron.se>

- Removed unportable cc switches from the spec file. The defaults can
  now be overridden with environment variables. This feature is used
  to compile the official RPM with optimal (but compiler version
  specific) switches.

- Removed the repetitive description parts for the sub rpms. Maybe add
  again if RPM gets a multiline macro capability.

- Added support for a pt_BR translation. Translation contributed by
  Jorge Godoy <jorge@bestway.com.br>.

* Wed Nov 4 1998 David Axmark <david@detron.se>

- A lot of changes in all the rpm and install scripts. This may even
  be a working RPM :-)

* Sun Aug 16 1998 David Axmark <david@detron.se>

- A developers changelog for MySQL is available in the source RPM. And
  there is a history of major user visible changed in the Reference
  Manual.  Only RPM specific changes will be documented here.
